

   MEMBER('eip.clw')                                  ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABPOPUP.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('EIP003.INC'),ONCE        !Local module procedure declarations
                       INCLUDE('EIP005.INC'),ONCE        !Req'd for module callout resolution
                     END


BrowseCustomers PROCEDURE                             !Generated from procedure template - Window

FilesOpened          BYTE
BRW1::View:Browse    VIEW(Customer)
                       PROJECT(CUS:Name)
                       PROJECT(CUS:Number)
                       PROJECT(CUS:Phone)
                       PROJECT(CUS:Contact)
                       PROJECT(CUS:CustomerId)
                     END
Queue:Browse         QUEUE                            !Queue declaration for browse/combo box using ?List
CUS:Name               LIKE(CUS:Name)                 !List box control field - type derived from field
CUS:Number             LIKE(CUS:Number)               !List box control field - type derived from field
CUS:Phone              LIKE(CUS:Phone)                !List box control field - type derived from field
CUS:Contact            LIKE(CUS:Contact)              !List box control field - type derived from field
CUS:CustomerId         LIKE(CUS:CustomerId)           !Primary key field - type derived from field
Mark                   BYTE                           !Entry's marked status
ViewPosition           STRING(1024)                   !Entry's view position
                     END
BrowseWindow         WINDOW('List of Customers by Name'),AT(0,0,399,230),FONT('Bookman Old Style',10,,300,CHARSET:ANSI),COLOR(0BAA596H),SYSTEM,GRAY,MDI
                       SHEET,AT(4,8,391,202),USE(?Sheet1)
                         TAB('by Name'),USE(?Tab:ByName)
                         END
                         TAB('by Number'),USE(?Tab:ByNumber)
                         END
                       END
                       PANEL,AT(8,28,383,174),USE(?Panel1),FILL(0937E64H),BEVEL(-2)
                       LIST,AT(15,35,368,158),USE(?List),IMM,HVSCROLL,FONT('Bookman Old Style',10,,,CHARSET:ANSI),COLOR(0F4F9FFH,,0937E64H),MSG('Browsing Records'),FORMAT('124L|M~Name~@s30@31L|M~Number~@s4@55L|M~Phone~@s10@80L|M~Contact~@s20@'),FROM(Queue:Browse)
                       BUTTON('&Insert'),AT(18,214,41,12),USE(?Insert),FLAT,LEFT,KEY(InsertKey),ICON('wizins.gif')
                       BUTTON('&Change'),AT(59,214,49,12),USE(?Change),FLAT,LEFT,KEY(CtrlEnter),ICON('wizedit.gif'),DEFAULT
                       BUTTON('&Delete'),AT(109,214,43,12),USE(?Delete),FLAT,LEFT,KEY(DeleteKey),ICON('wizdel.gif')
                       BUTTON('&Select'),AT(292,214,47,12),USE(?Select),FLAT,LEFT,KEY(EnterKey),ICON('WIZMARK.gif')
                       BUTTON('Close'),AT(342,214,40,12),USE(?Close),FLAT,LEFT,ICON('wizcncl.gif')
                     END

ThisWindow           CLASS(WindowManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(USHORT Number,BYTE Request),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
BRW1                 CLASS(BrowseClass)               !Browse using ?List
Q                      &Queue:Browse                  !Reference to browse queue
Init                   PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)
ResetSort              PROCEDURE(BYTE Force),BYTE,PROC,DERIVED
                     END

BRW1::Sort0:Locator  IncrementalLocatorClass          !Default Locator
BRW1::Sort1:Locator  IncrementalLocatorClass          !Conditional Locator - Choice(?Sheet1) = 2

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('BrowseCustomers')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Panel1
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  SELF.AddItem(?Close,RequestCancelled)
  Relate:Customer.Open
  SELF.FilesOpened = True
  BRW1.Init(?List,Queue:Browse.ViewPosition,BRW1::View:Browse,Queue:Browse,Relate:Customer,SELF)
  OPEN(BrowseWindow)
  SELF.Opened=True
  BRW1.Q &= Queue:Browse
  BRW1.AddSortOrder(,CUS:NumberK)
  BRW1.AddLocator(BRW1::Sort1:Locator)
  BRW1::Sort1:Locator.Init(,CUS:Number,1,BRW1)
  BRW1.AddSortOrder(,CUS:NameK)
  BRW1.AddLocator(BRW1::Sort0:Locator)
  BRW1::Sort0:Locator.Init(,CUS:Name,1,BRW1)
  BRW1.AddField(CUS:Name,BRW1.Q.CUS:Name)
  BRW1.AddField(CUS:Number,BRW1.Q.CUS:Number)
  BRW1.AddField(CUS:Phone,BRW1.Q.CUS:Phone)
  BRW1.AddField(CUS:Contact,BRW1.Q.CUS:Contact)
  BRW1.AddField(CUS:CustomerId,BRW1.Q.CUS:CustomerId)
  BRW1.AskProcedure = 1
  BRW1.AddToolbarTarget(Toolbar)
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Customer.Close
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE(USHORT Number,BYTE Request)

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run(Number,Request)
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled
  ELSE
    GlobalRequest = Request
    EditCustomers
    ReturnValue = GlobalResponse
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?Select
      ThisWindow.Update
      !
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


BRW1.Init PROCEDURE(SIGNED ListBox,*STRING Posit,VIEW V,QUEUE Q,RelationManager RM,WindowManager WM)

  CODE
  PARENT.Init(ListBox,Posit,V,Q,RM,WM)
  SELF.SelectControl = ?Select
  SELF.HideSelect = 1
  IF WM.Request <> ViewRecord
    SELF.InsertControl=?Insert
    SELF.ChangeControl=?Change
    SELF.DeleteControl=?Delete
  END


BRW1.ResetSort PROCEDURE(BYTE Force)

ReturnValue          BYTE,AUTO

  CODE
  IF Choice(?Sheet1) = 2
    RETURN SELF.SetSort(1,Force)
  ELSE
    RETURN SELF.SetSort(2,Force)
  END
  ReturnValue = PARENT.ResetSort(Force)
  RETURN ReturnValue

