

   MEMBER('eip.clw')                                  ! This is a MEMBER module


   INCLUDE('ABBROWSE.INC'),ONCE
   INCLUDE('ABREPORT.INC'),ONCE

                     MAP
                       INCLUDE('EIP008.INC'),ONCE        !Local module procedure declarations
                     END


PrintInventory PROCEDURE                              !Generated from procedure template - Report

Progress:Thermometer BYTE
Process:View         VIEW(Item)
                       PROJECT(ITM:Cost)
                       PROJECT(ITM:Description)
                       PROJECT(ITM:ItemNumber)
                       PROJECT(ITM:List)
                       PROJECT(ITM:Sell)
                       PROJECT(ITM:UOM)
                     END
ReportPageNumber     LONG,AUTO
ProgressWindow       WINDOW('Progress...'),AT(,,142,59),CENTER,TIMER(1),GRAY,DOUBLE
                       PROGRESS,USE(Progress:Thermometer),AT(15,15,111,12),RANGE(0,100)
                       STRING(''),AT(0,3,141,10),USE(?Progress:UserString),CENTER
                       STRING(''),AT(0,30,141,10),USE(?Progress:PctText),CENTER
                       BUTTON('Cancel'),AT(45,42,50,15),USE(?Progress:Cancel)
                     END

Report               REPORT('Inventory Report'),AT(271,1521,7958,8469),PAPER(PAPER:LETTER),PRE(RPT),FONT('Courier New',8,,FONT:regular,CHARSET:ANSI),THOUS
                       HEADER,AT(333,521,7917,802),USE(?Header)
                         STRING('Inventory Report'),AT(73,42,7760,260),USE(?ReportHeader),TRN,CENTER,FONT('Arial',14,,FONT:bold,CHARSET:ANSI)
                         STRING('Report Time:'),AT(5500,458),USE(?ReportTimePrompt),TRN
                         STRING('<<-- Time Stamp -->'),AT(6500,458),USE(?ReportTimeStamp),TRN
                         LINE,AT(52,698,7771,0),USE(?Line1),COLOR(COLOR:Black),LINEWIDTH(25)
                         STRING('Report Date:'),AT(83,458),USE(?ReportDatePrompt),TRN
                         STRING('<<-- Date Stamp -->'),AT(1083,458),USE(?ReportDateStamp),TRN
                       END
detail                 DETAIL,AT(21,,3417,),USE(?Detail)
                         GROUP,AT(31,10,3292,990),USE(?Group1),BOXED
                         END
                         STRING(@s10),AT(52,156),USE(ITM:ItemNumber)
                         STRING(@s30),AT(52,313),USE(ITM:Description)
                         IMAGE,AT(2333,125,917,760),USE(?Image1),CENTERED
                         STRING(@n-10.2),AT(52,479),USE(ITM:Cost),RIGHT
                         STRING(@n-10.2),AT(917,479),USE(ITM:List),RIGHT
                         STRING(@n-10.2),AT(917,656),USE(ITM:Sell),RIGHT
                         STRING(@s2),AT(52,667),USE(ITM:UOM)
                       END
                       FOOTER,AT(240,10010,7979,688),USE(?Footer)
                         LINE,AT(63,42,7771,0),USE(?Line1:2),COLOR(COLOR:Black),LINEWIDTH(25)
                         STRING('Page:'),AT(3635,146),USE(?PageString),TRN
                         STRING(@N3),AT(4052,146),USE(ReportPageNumber)
                       END
                       FORM,AT(10,10,8479,11021),USE(?unnamed)
                       END
                     END
ThisWindow           CLASS(ReportManager)
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
OpenReport             PROCEDURE(),BYTE,PROC,DERIVED
TakeRecord             PROCEDURE(),BYTE,PROC,DERIVED
                     END

ThisReport           CLASS(ProcessClass)              !Process Manager
TakeRecord             PROCEDURE(),BYTE,PROC,DERIVED
                     END

ProgressMgr          StepStringClass                  !Progress Manager
Previewer            PrintPreviewClass                !Print Previewer

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('PrintInventory')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Progress:Thermometer
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  Relate:Item.Open
  SELF.FilesOpened = True
  OPEN(ProgressWindow)
  SELF.Opened=True
  ProgressMgr.Init(ScrollSort:AllowAlpha+ScrollSort:AllowNumeric,ScrollBy:RunTime)
  ThisReport.Init(Process:View, Relate:Item, ?Progress:PctText, Progress:Thermometer, ProgressMgr, ITM:ItemNumber)
  ThisReport.CaseSensitiveValue = FALSE
  ThisReport.AddSortOrder(ITM:ItemNumberK)
  SELF.AddItem(?Progress:Cancel,RequestCancelled)
  SELF.Init(ThisReport,Report,Previewer)
  ?Progress:UserString{Prop:Text}=''
  Relate:Item.SetQuickScan(1,Propagate:OneMany)
  SELF.Zoom = PageWidth
  Previewer.AllowUserZoom=True
  Previewer.Maximize=True
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Item.Close
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.OpenReport PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.OpenReport()
  IF ~ReturnValue
    SELF.Report$?ReportDateStamp{PROP:Text}=FORMAT(TODAY(),@D18)
  END
  IF ~ReturnValue
    SELF.Report$?ReportTimeStamp{PROP:Text}=FORMAT(CLOCK(),@T8)
  END
  IF ~ReturnValue
    Report$?ReportPageNumber{PROP:PageNo}=True
  END
  RETURN ReturnValue


ThisWindow.TakeRecord PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  Report$?Image1{PROP:Text} = CLIP(ITM:IconFile)
  ReturnValue = PARENT.TakeRecord()
  RETURN ReturnValue


ThisReport.TakeRecord PROCEDURE

ReturnValue          BYTE,AUTO

SkipDetails BYTE
  CODE
  ReturnValue = PARENT.TakeRecord()
  PRINT(RPT:detail)
  RETURN ReturnValue

