

   MEMBER('eip.clw')                                  ! This is a MEMBER module


   INCLUDE('ABRESIZE.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('EIP005.INC'),ONCE        !Local module procedure declarations
                     END


EditCustomers PROCEDURE                               !Generated from procedure template - Window

CurrentTab           STRING(80)
FilesOpened          BYTE
ActionMessage        CSTRING(40)
History::CUS:Record  LIKE(CUS:RECORD),STATIC
QuickWindow          WINDOW('Update the Customer File'),AT(,,283,148),FONT('Bookman Old Style',9,,,CHARSET:ANSI),COLOR(0BAA596H),IMM,HLP('CustomerFrm'),SYSTEM,GRAY,RESIZE,MDI
                       PANEL,AT(0,0,283,128),USE(?Panel2),FILL(0937E64H)
                       PANEL,AT(5,5,273,115),USE(?Panel1),FILL(0BAA596H),BEVEL(-2)
                       STRING(@s39),AT(73,11,138,10),USE(ActionMessage),CENTER,FONT(,,COLOR:Yellow,,CHARSET:ANSI)
                       PROMPT('Number:'),AT(29,28),USE(?CUS:Number:Prompt)
                       ENTRY(@s4),AT(61,28,,10),USE(CUS:Number),COLOR(0E1EEFFH),MSG('Customer Number'),TIP('Customer Number'),UPR
                       PROMPT('Name:'),AT(35,42),USE(?CUS:Name:Prompt)
                       ENTRY(@s30),AT(61,42,,10),USE(CUS:Name),COLOR(0E1EEFFH),MSG('Customer Name'),TIP('Customer Name'),REQ
                       PROMPT('Address:'),AT(29,56),USE(?CUS:Address:Prompt)
                       ENTRY(@s20),AT(61,56,,10),USE(CUS:Address),COLOR(0E1EEFFH),MSG('Customer Address'),TIP('Customer Address'),REQ
                       PROMPT('City:'),AT(41,70),USE(?CUS:City:Prompt)
                       ENTRY(@s15),AT(61,70,,10),USE(CUS:City),COLOR(0E1EEFFH),MSG('Customer City'),TIP('Customer City'),REQ
                       PROMPT('State:'),AT(123,71),USE(?CUS:State:Prompt)
                       ENTRY(@s2),AT(143,70,,10),USE(CUS:State),COLOR(0E1EEFFH),MSG('Customer State'),TIP('Customer State'),REQ,UPR
                       PROMPT('Zip:'),AT(161,71),USE(?CUS:Zip:Prompt)
                       ENTRY(@s10),AT(178,70,,10),USE(CUS:Zip),COLOR(0E1EEFFH),MSG('Customer Zip'),TIP('Customer Zip'),REQ
                       PROMPT('Phone:'),AT(34,85),USE(?CUS:Phone:Prompt)
                       ENTRY(@P(###) ###-####P),AT(61,84,49,10),USE(CUS:Phone),COLOR(0E1EEFFH),MSG('Customer Phone Number'),TIP('Customer Phone Number')
                       PROMPT('Fax:'),AT(117,85),USE(?CUS:Fax:Prompt)
                       ENTRY(@P(###) ###-####P),AT(135,84,49,10),USE(CUS:Fax),COLOR(0E1EEFFH),MSG('Customer Fax Number'),TIP('Customer Fax Number')
                       PROMPT('Toll Free:'),AT(189,85),USE(?CUS:TollFree:Prompt)
                       ENTRY(@P(###) ###-####P),AT(223,84,51,10),USE(CUS:TollFree),COLOR(0E1EEFFH),MSG('Customer Toll Free Number'),TIP('Customer Toll Free Number')
                       PROMPT('Contact:'),AT(29,98),USE(?CUS:Contact:Prompt)
                       ENTRY(@s20),AT(60,98,,10),USE(CUS:Contact),COLOR(0E1EEFFH),MSG('Contact Name'),TIP('Contact Name')
                       BUTTON('OK'),AT(6,130,45,14),USE(?OK),FLAT,LEFT,ICON('wizok.gif'),DEFAULT
                       BUTTON('Cancel'),AT(50,130,45,14),USE(?Cancel),FLAT,LEFT,ICON('wizcncl.gif')
                       PANEL,AT(0,128,283,20),USE(?Panel3)
                     END

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END

CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Ask PROCEDURE

  CODE
  CASE SELF.Request
  OF ViewRecord
    ActionMessage = 'View Customers'
  OF InsertRecord
    ActionMessage = 'Customer Will Be Added'
  OF ChangeRecord
    ActionMessage = 'Customer Will Be Changed'
  OF DeleteRecord
    ActionMessage = 'Customer Will Be Deleted'
  END
  QuickWindow{Prop:Text} = ActionMessage
  CASE SELF.Request
  OF ChangeRecord OROF DeleteRecord
    QuickWindow{Prop:Text} = QuickWindow{Prop:Text} & '  (' & CLIP(CUS:Name) & ')'
  OF InsertRecord
    QuickWindow{Prop:Text} = QuickWindow{Prop:Text} & '  (New)'
  END
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('EditCustomers')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Panel2
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  SELF.HistoryKey = 734
  SELF.AddHistoryFile(CUS:Record,History::CUS:Record)
  SELF.AddHistoryField(?CUS:Number,2)
  SELF.AddHistoryField(?CUS:Name,3)
  SELF.AddHistoryField(?CUS:Address,4)
  SELF.AddHistoryField(?CUS:City,5)
  SELF.AddHistoryField(?CUS:State,6)
  SELF.AddHistoryField(?CUS:Zip,7)
  SELF.AddHistoryField(?CUS:Phone,8)
  SELF.AddHistoryField(?CUS:Fax,9)
  SELF.AddHistoryField(?CUS:TollFree,10)
  SELF.AddHistoryField(?CUS:Contact,11)
  SELF.AddUpdateFile(Access:Customer)
  SELF.AddItem(?Cancel,RequestCancelled)
  Relate:Customer.Open
  SELF.FilesOpened = True
  SELF.Primary &= Relate:Customer
  IF SELF.Request = ViewRecord
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = 0
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.DeleteAction = Delete:Form
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
  OPEN(QuickWindow)
  SELF.Opened=True
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)
  SELF.AddItem(Resizer)
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Customer.Close
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run()
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?OK
      ThisWindow.Update
      IF SELF.Request = ViewRecord
        POST(EVENT:CloseWindow)
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults

