

   MEMBER('eip.clw')                                  ! This is a MEMBER module


   INCLUDE('ABRESIZE.INC'),ONCE
   INCLUDE('ABTOOLBA.INC'),ONCE
   INCLUDE('ABUTIL.INC'),ONCE
   INCLUDE('ABWINDOW.INC'),ONCE

                     MAP
                       INCLUDE('EIP007.INC'),ONCE        !Local module procedure declarations
                     END


UpdateItems PROCEDURE                                 !Generated from procedure template - Window

CurrentTab           STRING(80)
FilesOpened          BYTE
ActionMessage        CSTRING(40)
History::ITM:Record  LIKE(ITM:RECORD),STATIC
QuickWindow          WINDOW('Update Item File'),AT(,,213,157),FONT('Bookman Old Style',9,,,CHARSET:ANSI),COLOR(0BAA596H),IMM,HLP('CustomerFrm'),SYSTEM,GRAY,RESIZE,MDI
                       PANEL,AT(0,0,213,137),USE(?Panel2),FILL(0937E64H)
                       PANEL,AT(4,5,204,126),USE(?Panel1),FILL(0BAA596H),BEVEL(-2)
                       PROMPT('Item Number:'),AT(16,10),USE(?ITM:Number:Prompt)
                       ENTRY(@s10),AT(66,10,,10),USE(ITM:ItemNumber),COLOR(0E1EEFFH),MSG('Unique Item Number'),TIP('Unique Item Number')
                       PROMPT('Sell:'),AT(44,80),USE(?ITM:Sell:Prompt)
                       SPIN(@n-10.2),AT(66,80,,10),USE(ITM:Sell),HVSCROLL,DECIMAL(12),COLOR(0E1EEFFH),MSG('Item Sell Price'),TIP('Item Sell Price'),STEP(0.1)
                       PROMPT('Description:'),AT(21,24),USE(?ITM:Description:Prompt)
                       ENTRY(@s30),AT(66,24,,10),USE(ITM:Description),COLOR(0E1EEFFH),MSG('Item Description'),TIP('Item Description')
                       PROMPT('UOM:'),AT(41,38),USE(?ITM:UOM:Prompt)
                       ENTRY(@s2),AT(66,38,,10),USE(ITM:UOM),COLOR(0E1EEFFH),MSG('Item Unit of Measure'),TIP('Item Unit of Measure')
                       PROMPT('List:'),AT(44,66),USE(?ITM:List:Prompt)
                       SPIN(@n-10.2),AT(66,66,,10),USE(ITM:List),HVSCROLL,DECIMAL(12),COLOR(0E1EEFFH),MSG('Item List Price'),TIP('Item List Price'),STEP(0.1)
                       PROMPT('Cost:'),AT(42,52),USE(?ITM:Cost:Prompt)
                       SPIN(@n-10.2),AT(66,52,,10),USE(ITM:Cost),HVSCROLL,DECIMAL(12),COLOR(0E1EEFFH),MSG('Item Cost'),TIP('Item Cost'),STEP(0.1)
                       PROMPT('Image File:'),AT(25,94),USE(?ITM:ImageFile:Prompt)
                       TEXT,AT(66,94,120,10),USE(ITM:IconFile),COLOR(0E1EEFFH),MSG('Contact Name'),TIP('Contact Name')
                       BUTTON('Find image'),AT(65,108,,12),USE(?LookupFile),LEFT,ICON('wizfind.gif')
                       IMAGE,AT(138,41,48,45),USE(?Image1),CENTERED
                       BUTTON('OK'),AT(62,140,45,14),USE(?OK),FLAT,LEFT,ICON('wizok.gif'),DEFAULT
                       BUTTON('Cancel'),AT(106,140,45,14),USE(?Cancel),FLAT,LEFT,ICON('wizcncl.gif')
                       PANEL,AT(0,137,213,20),USE(?Panel3)
                     END

ThisWindow           CLASS(WindowManager)
Ask                    PROCEDURE(),DERIVED
Init                   PROCEDURE(),BYTE,PROC,DERIVED
Kill                   PROCEDURE(),BYTE,PROC,DERIVED
Run                    PROCEDURE(),BYTE,PROC,DERIVED
TakeAccepted           PROCEDURE(),BYTE,PROC,DERIVED
TakeWindowEvent        PROCEDURE(),BYTE,PROC,DERIVED
                     END

Toolbar              ToolbarClass
Resizer              CLASS(WindowResizeClass)
Init                   PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)
                     END

GIFLookUp            SelectFileClass
CurCtrlFeq          LONG
FieldColorQueue     QUEUE
Feq                   LONG
OldColor              LONG
                    END

  CODE
  GlobalResponse = ThisWindow.Run()


ThisWindow.Ask PROCEDURE

  CODE
  CASE SELF.Request
  OF ViewRecord
    ActionMessage = 'View Item'
  OF InsertRecord
    ActionMessage = 'Item Will Be Added'
  OF ChangeRecord
    ActionMessage = 'Item Will Be Changed'
  OF DeleteRecord
    ActionMessage = 'Item Will Be Deleted'
  END
  QuickWindow{Prop:Text} = ActionMessage
  CASE SELF.Request
  OF ChangeRecord OROF DeleteRecord
    QuickWindow{Prop:Text} = QuickWindow{Prop:Text} & '  (' & CLIP(ITM:Description) & ')'
  OF InsertRecord
    QuickWindow{Prop:Text} = QuickWindow{Prop:Text} & '  (New)'
  END
  PARENT.Ask


ThisWindow.Init PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  GlobalErrors.SetProcedureName('UpdateItems')
  SELF.Request = GlobalRequest
  ReturnValue = PARENT.Init()
  IF ReturnValue THEN RETURN ReturnValue.
  SELF.FirstField = ?Panel2
  SELF.VCRRequest &= VCRRequest
  SELF.Errors &= GlobalErrors
  SELF.AddItem(Toolbar)
  CLEAR(GlobalRequest)
  CLEAR(GlobalResponse)
  SELF.HistoryKey = 734
  SELF.AddHistoryFile(ITM:Record,History::ITM:Record)
  SELF.AddHistoryField(?ITM:ItemNumber,2)
  SELF.AddHistoryField(?ITM:Sell,6)
  SELF.AddHistoryField(?ITM:Description,3)
  SELF.AddHistoryField(?ITM:UOM,7)
  SELF.AddHistoryField(?ITM:List,5)
  SELF.AddHistoryField(?ITM:Cost,4)
  SELF.AddHistoryField(?ITM:IconFile,8)
  SELF.AddUpdateFile(Access:Item)
  SELF.AddItem(?Cancel,RequestCancelled)
  Relate:Customer.Open
  Relate:Item.Open
  SELF.FilesOpened = True
  SELF.Primary &= Relate:Item
  IF SELF.Request = ViewRecord
    SELF.InsertAction = Insert:None
    SELF.DeleteAction = Delete:None
    SELF.ChangeAction = 0
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = 0
  ELSE
    SELF.DeleteAction = Delete:Form
    SELF.CancelAction = Cancel:Cancel
    SELF.OkControl = ?OK
    IF SELF.PrimeUpdate() THEN RETURN Level:Notify.
  END
  OPEN(QuickWindow)
  SELF.Opened=True
  Resizer.Init(AppStrategy:Surface,Resize:SetMinSize)
  SELF.AddItem(Resizer)
  GIFLookUp.Init
  GIFLookUp.Flags=BOR(GIFLookUp.Flags,FILE:LongName)
  GIFLookUp.SetMask('GIF Files','*.GIF')
  GIFLookUp.WindowTitle='Find GIF files'
  SELF.SetAlerts()
  RETURN ReturnValue


ThisWindow.Kill PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Kill()
  IF ReturnValue THEN RETURN ReturnValue.
  IF SELF.FilesOpened
    Relate:Customer.Close
    Relate:Item.Close
  END
  GlobalErrors.SetProcedureName
  RETURN ReturnValue


ThisWindow.Run PROCEDURE

ReturnValue          BYTE,AUTO

  CODE
  ReturnValue = PARENT.Run()
  IF SELF.Request = ViewRecord
    ReturnValue = RequestCancelled
  END
  RETURN ReturnValue


ThisWindow.TakeAccepted PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeAccepted()
    CASE ACCEPTED()
    OF ?LookupFile
      ThisWindow.Update
      ITM:IconFile = GIFLookUp.Ask(1)
      IF INSTRING('\',ITM:IconFile,1,1)
        Len# = LEN(CLIP(ITM:IconFile))
        LOOP Ndx# = Len# TO 1 BY -1
          IF ITM:IconFile[Ndx#] = '\' THEN BREAK.
        END
        x" = ITM:IconFile[Ndx# + 1 : Len#]
      END
      ITM:IconFile = x"
      !!Update the image of the product
      ?Image1{PROP:Text} = CLIP(ITM:IconFile)
    OF ?OK
      ThisWindow.Update
      IF SELF.Request = ViewRecord
        POST(EVENT:CloseWindow)
      END
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


ThisWindow.TakeWindowEvent PROCEDURE

ReturnValue          BYTE,AUTO

Looped BYTE
  CODE
  LOOP
    IF Looped
      RETURN Level:Notify
    ELSE
      Looped = 1
    END
  ReturnValue = PARENT.TakeWindowEvent()
    CASE EVENT()
    OF EVENT:OpenWindow
      !!Update the image of the product
      ?Image1{PROP:Text} = CLIP(ITM:IconFile)
    END
    RETURN ReturnValue
  END
  ReturnValue = Level:Fatal
  RETURN ReturnValue


Resizer.Init PROCEDURE(BYTE AppStrategy=AppStrategy:Resize,BYTE SetWindowMinSize=False,BYTE SetWindowMaxSize=False)


  CODE
  PARENT.Init(AppStrategy,SetWindowMinSize,SetWindowMaxSize)
  SELF.SetParentDefaults

